using System;
using System.Collections.Generic;
using System.Text;
using System.Data.OleDb;

namespace Shop.DAL
{
    class MyCustomersTableAdapter : SalesDataSetTableAdapters.CustomersTableAdapter
    {
        public override int Update(SalesDataSet dataSet)
        {
            // no seria necessario se existisse stored procedure que insiria o registo
            // e devolvia o ID do registo criado
            dataSet.Customers.RowChanged += new System.Data.DataRowChangeEventHandler(Customers_RowChanged);
            return base.Update(dataSet);
        }

        void Customers_RowChanged(object sender, System.Data.DataRowChangeEventArgs e)
        {
            if (e.Action == System.Data.DataRowAction.Commit)
            {
                SalesDataSet.CustomersDataTable dt = (SalesDataSet.CustomersDataTable)sender;
                e.Row.BeginEdit();
                OleDbCommand cmd = new OleDbCommand("SELECT @@IDENTITY", Connection);
                e.Row["CustomerID"] = (int)cmd.ExecuteScalar();
                e.Row.EndEdit();
            }
        }
    }
}
